<?php 
/**
 * Anwiki is a multilingual content management system <http://www.anwiki.com>
 * Copyright (C) 2007-2008 Antoine Walter <http://www.anw.fr>
 * 
 * Anwiki is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 3 of the License.
 * 
 * Anwiki is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Anwiki.  If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * Anwiki main script.
 * @package Anwiki
 * @version $Id: index.php,v 1.18 2008-09-11 22:43:38 antoine-cvs Exp $
 * @copyright 2007-2008 Antoine Walter
 * @license http://www.gnu.org/copyleft/gpl.html GNU Public License 3
 */

try
{
	//should we load minimal mode?
	if (in_array($_GET['a'], array('install')) || isset($_GET['anwiki_mode_minimal']))
	{
		define('ANWIKI_MODE_MINIMAL', true);
	}
	else
	{
		define('ANWIKI_MODE_MINIMAL', false);
	}
	
	//define the default file to load
	define('ANWFILE_INC', 'anwiki.inc.php');
	
	//load Anwiki environment
	if (file_exists("_anwiki-override.inc.php"))
	{
		require_once("_anwiki-override.inc.php");
	}
	else
	{		
		require_once(ANWFILE_INC);
	}
	
	//install redirect
	if (!file_exists(ANWIKI_INSTALL_LOCK) && AnwEnv::_GET('a')!='install')
	{
		$sUrlInstall = AnwEnv::_SERVER('SCRIPT_URI').'?a=install';
		header("Location: ".$sUrlInstall);
		print '<a href="'.$sUrlInstall.'">'.$sUrlInstall.'</a>';
		exit;
	}
	
	AnwDebug::startbench("preparing action", true);
	
	//load action code
	try
	{
		$sAction = strtolower( AnwEnv::_GET(AnwAction::GET_ACTIONNAME, "view") );
		$oAction = AnwAction::loadComponent($sAction);
	}
	catch(AnwException $e)
	{
		$sAction = "view";
		$oAction = AnwAction::loadComponent($sAction);
	}
	
	//security check
	if (ANWIKI_MODE_MINIMAL && !($oAction instanceof AnwActionMinimal))
	{
		AnwDieCriticalError("Unauthorized mode / bad URL");
	}
	
	$oAction->setAsCurrentAction();
	AnwDebug::log("Action : ".$sAction);
	AnwDebug::stopbench("preparing action");
	//run
	$oAction->runAndOutput();
}
catch(AnwException $e)
{
	errorApp($e);
}
?>